package org.dromara.inspection.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.inspection.domain.bo.OpsInspectionTaskProblemBo;
import org.dromara.inspection.domain.vo.OpsInspectionTaskProblemVo;
import org.dromara.inspection.domain.OpsInspectionTaskProblem;
import org.dromara.inspection.mapper.OpsInspectionTaskProblemMapper;
import org.dromara.inspection.service.IOpsInspectionTaskProblemService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 运维-巡检-任务-问题Service业务层处理
 *
 * @author LionLi
 * @date 2025-09-26
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class OpsInspectionTaskProblemServiceImpl implements IOpsInspectionTaskProblemService {

    private final OpsInspectionTaskProblemMapper baseMapper;

    /**
     * 查询运维-巡检-任务-问题
     *
     * @param id 主键
     * @return 运维-巡检-任务-问题
     */
    @Override
    public OpsInspectionTaskProblemVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询运维-巡检-任务-问题列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 运维-巡检-任务-问题分页列表
     */
    @Override
    public TableDataInfo<OpsInspectionTaskProblemVo> queryPageList(OpsInspectionTaskProblemBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<OpsInspectionTaskProblem> lqw = buildQueryWrapper(bo);
        Page<OpsInspectionTaskProblemVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的运维-巡检-任务-问题列表
     *
     * @param bo 查询条件
     * @return 运维-巡检-任务-问题列表
     */
    @Override
    public List<OpsInspectionTaskProblemVo> queryList(OpsInspectionTaskProblemBo bo) {
        LambdaQueryWrapper<OpsInspectionTaskProblem> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<OpsInspectionTaskProblem> buildQueryWrapper(OpsInspectionTaskProblemBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<OpsInspectionTaskProblem> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(OpsInspectionTaskProblem::getId);
        lqw.eq(bo.getTaskId() != null, OpsInspectionTaskProblem::getTaskId, bo.getTaskId());
        lqw.eq(StringUtils.isNotBlank(bo.getType()), OpsInspectionTaskProblem::getType, bo.getType());
        lqw.eq(StringUtils.isNotBlank(bo.getInfo()), OpsInspectionTaskProblem::getInfo, bo.getInfo());
        lqw.eq(bo.getFindTime() != null, OpsInspectionTaskProblem::getFindTime, bo.getFindTime());
        lqw.eq(StringUtils.isNotBlank(bo.getFinish()), OpsInspectionTaskProblem::getFinish, bo.getFinish());
        lqw.eq(bo.getFinishTime() != null, OpsInspectionTaskProblem::getFinishTime, bo.getFinishTime());
        return lqw;
    }

    /**
     * 新增运维-巡检-任务-问题
     *
     * @param bo 运维-巡检-任务-问题
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(OpsInspectionTaskProblemBo bo) {
        OpsInspectionTaskProblem add = MapstructUtils.convert(bo, OpsInspectionTaskProblem.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改运维-巡检-任务-问题
     *
     * @param bo 运维-巡检-任务-问题
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(OpsInspectionTaskProblemBo bo) {
        OpsInspectionTaskProblem update = MapstructUtils.convert(bo, OpsInspectionTaskProblem.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(OpsInspectionTaskProblem entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除运维-巡检-任务-问题信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
